/* AppLock.c generated by valac 0.38.10, the Vala compiler
 * generated from AppLock.vala, do not modify */

/*
 * AppLock.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <unistd.h>


#define TYPE_APP_LOCK (app_lock_get_type ())
#define APP_LOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_LOCK, AppLock))
#define APP_LOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_LOCK, AppLockClass))
#define IS_APP_LOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_LOCK))
#define IS_APP_LOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_LOCK))
#define APP_LOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_LOCK, AppLockClass))

typedef struct _AppLock AppLock;
typedef struct _AppLockClass AppLockClass;
typedef struct _AppLockPrivate AppLockPrivate;
enum  {
	APP_LOCK_0_PROPERTY,
	APP_LOCK_NUM_PROPERTIES
};
static GParamSpec* app_lock_properties[APP_LOCK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AppLock {
	GObject parent_instance;
	AppLockPrivate * priv;
	gchar* lock_file;
	gchar* lock_message;
};

struct _AppLockClass {
	GObjectClass parent_class;
};


static gpointer app_lock_parent_class = NULL;

GType app_lock_get_type (void) G_GNUC_CONST;
gboolean app_lock_create (AppLock* self, const gchar* app_name, const gchar* message);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path, gboolean show_message);
gchar* tee_jee_file_system_path_combine (const gchar* path1, const gchar* path2);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
gboolean tee_jee_process_helper_process_is_running (glong pid);
void tee_jee_logging_log_msg (const gchar* message, gboolean highlight);
static void app_lock_write_lock_file (AppLock* self, const gchar* message);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
gboolean tee_jee_file_system_file_write (const gchar* file_path, const gchar* contents);
void app_lock_remove (AppLock* self);
AppLock* app_lock_new (void);
AppLock* app_lock_construct (GType object_type);
static void app_lock_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1242 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _result_;
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 108 "AppLock.c"
}


gboolean app_lock_create (AppLock* self, const gchar* app_name, const gchar* message) {
	gboolean result = FALSE;
	gchar* lock_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp38_ = FALSE;
	GError * _inner_error_ = NULL;
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	g_return_val_if_fail (app_name != NULL, FALSE);
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 35 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp0_ = app_name;
#line 35 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp1_ = g_strdup_printf ("/var/run/lock/%s", _tmp0_);
#line 35 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	lock_dir = _tmp1_;
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp2_ = lock_dir;
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	tee_jee_file_system_dir_create (_tmp2_, FALSE);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp3_ = lock_dir;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp4_ = tee_jee_file_system_path_combine (_tmp3_, "lock");
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_g_free0 (self->lock_file);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	self->lock_file = _tmp4_;
#line 146 "AppLock.c"
	{
		GFile* file = NULL;
		const gchar* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		gboolean _tmp8_;
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp5_ = self->lock_file;
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp6_ = g_file_new_for_path (_tmp5_);
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		file = _tmp6_;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp7_ = file;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp8_ = g_file_query_exists (_tmp7_, NULL);
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		if (_tmp8_) {
#line 165 "AppLock.c"
			gchar* txt = NULL;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* process_id = NULL;
			const gchar* _tmp11_;
			gchar** _tmp12_;
			gchar** _tmp13_;
			gchar** _tmp14_;
			gint _tmp14__length1;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar** _tmp19_;
			gchar** _tmp20_;
			gchar** _tmp21_;
			gint _tmp21__length1;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			glong pid = 0L;
			const gchar* _tmp24_;
			glong _tmp25_;
			glong _tmp26_;
			gboolean _tmp27_;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp9_ = self->lock_file;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp10_ = tee_jee_file_system_file_read (_tmp9_);
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			txt = _tmp10_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp11_ = txt;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, ";", 0);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp14_ = _tmp13_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp14__length1 = _vala_array_length (_tmp12_);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp15_ = _tmp14_[0];
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp16_ = string_strip (_tmp15_);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp17_ = _tmp16_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			process_id = _tmp17_;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp18_ = txt;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, ";", 0);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp21_ = _tmp20_;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp21__length1 = _vala_array_length (_tmp19_);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp22_ = _tmp21_[1];
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp23_ = string_strip (_tmp22_);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_g_free0 (self->lock_message);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			self->lock_message = _tmp23_;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp24_ = process_id;
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp25_ = atol (_tmp24_);
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			pid = _tmp25_;
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp26_ = pid;
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp27_ = tee_jee_process_helper_process_is_running (_tmp26_);
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			if (_tmp27_) {
#line 244 "AppLock.c"
				glong _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_tmp28_ = pid;
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_tmp29_ = g_strdup_printf (" (PID=%ld)", _tmp28_);
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_tmp30_ = _tmp29_;
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_tmp31_ = g_strconcat (_ ("Another instance of this application is running"), _tmp30_, NULL);
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_tmp32_ = _tmp31_;
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				tee_jee_logging_log_msg (_tmp32_, FALSE);
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_free0 (_tmp32_);
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_free0 (_tmp30_);
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				result = FALSE;
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_free0 (process_id);
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_free0 (txt);
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_object_unref0 (file);
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_free0 (lock_dir);
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				return result;
#line 278 "AppLock.c"
			} else {
				GFile* _tmp33_;
				const gchar* _tmp34_;
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				tee_jee_logging_log_msg (_ ("[Warning] Deleted invalid lock"), FALSE);
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_tmp33_ = file;
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				g_file_delete (_tmp33_, NULL, &_inner_error_);
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
					_g_free0 (process_id);
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
					_g_free0 (txt);
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
					_g_object_unref0 (file);
#line 296 "AppLock.c"
					goto __catch27_g_error;
				}
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_tmp34_ = message;
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				app_lock_write_lock_file (self, _tmp34_);
#line 57 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				result = TRUE;
#line 57 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_free0 (process_id);
#line 57 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_free0 (txt);
#line 57 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_object_unref0 (file);
#line 57 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_free0 (lock_dir);
#line 57 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				return result;
#line 315 "AppLock.c"
			}
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_g_free0 (process_id);
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_g_free0 (txt);
#line 321 "AppLock.c"
		} else {
			const gchar* _tmp35_;
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp35_ = message;
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			app_lock_write_lock_file (self, _tmp35_);
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			result = TRUE;
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_g_object_unref0 (file);
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_g_free0 (lock_dir);
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			return result;
#line 336 "AppLock.c"
		}
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_g_object_unref0 (file);
#line 340 "AppLock.c"
	}
	goto __finally27;
	__catch27_g_error:
	{
		GError* e = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		e = _inner_error_;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_inner_error_ = NULL;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp36_ = e;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp37_ = _tmp36_->message;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		tee_jee_logging_log_error (_tmp37_, FALSE, FALSE);
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		result = FALSE;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_g_error_free0 (e);
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_g_free0 (lock_dir);
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		return result;
#line 366 "AppLock.c"
	}
	__finally27:
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_g_free0 (lock_dir);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	g_clear_error (&_inner_error_);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	return _tmp38_;
#line 377 "AppLock.c"
}


static void app_lock_write_lock_file (AppLock* self, const gchar* message) {
	gchar* current_pid = NULL;
	pid_t _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	g_return_if_fail (self != NULL);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	g_return_if_fail (message != NULL);
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp0_ = getpid ();
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp1_ = g_strdup_printf ("%li", (glong) _tmp0_);
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	current_pid = _tmp1_;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp2_ = self->lock_file;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp3_ = message;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp4_ = g_strdup_printf ("%s;%s", current_pid, _tmp3_);
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp5_ = _tmp4_;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	tee_jee_file_system_file_write (_tmp2_, _tmp5_);
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_g_free0 (_tmp5_);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_g_free0 (current_pid);
#line 413 "AppLock.c"
}


void app_lock_remove (AppLock* self) {
	GError * _inner_error_ = NULL;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	g_return_if_fail (self != NULL);
#line 421 "AppLock.c"
	{
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		gboolean _tmp3_;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp0_ = self->lock_file;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp1_ = g_file_new_for_path (_tmp0_);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		file = _tmp1_;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp2_ = file;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp3_ = g_file_query_exists (_tmp2_, NULL);
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		if (_tmp3_) {
#line 440 "AppLock.c"
			GFile* _tmp4_;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			_tmp4_ = file;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			g_file_delete (_tmp4_, NULL, &_inner_error_);
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
				_g_object_unref0 (file);
#line 450 "AppLock.c"
				goto __catch28_g_error;
			}
		}
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_g_object_unref0 (file);
#line 456 "AppLock.c"
	}
	goto __finally28;
	__catch28_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		e = _inner_error_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_inner_error_ = NULL;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp5_ = e;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_tmp6_ = _tmp5_->message;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		_g_error_free0 (e);
#line 476 "AppLock.c"
	}
	__finally28:
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		g_clear_error (&_inner_error_);
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
		return;
#line 487 "AppLock.c"
	}
}


AppLock* app_lock_construct (GType object_type) {
	AppLock * self = NULL;
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	self = (AppLock*) g_object_new (object_type, NULL);
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	return self;
#line 498 "AppLock.c"
}


AppLock* app_lock_new (void) {
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	return app_lock_construct (TYPE_APP_LOCK);
#line 505 "AppLock.c"
}


static void app_lock_class_init (AppLockClass * klass) {
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	app_lock_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	G_OBJECT_CLASS (klass)->finalize = app_lock_finalize;
#line 514 "AppLock.c"
}


static void app_lock_instance_init (AppLock * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 30 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp0_ = g_strdup ("");
#line 30 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	self->lock_file = _tmp0_;
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_tmp1_ = g_strdup ("");
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	self->lock_message = _tmp1_;
#line 529 "AppLock.c"
}


static void app_lock_finalize (GObject * obj) {
	AppLock * self;
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_LOCK, AppLock);
#line 30 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_g_free0 (self->lock_file);
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	_g_free0 (self->lock_message);
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/AppLock.vala"
	G_OBJECT_CLASS (app_lock_parent_class)->finalize (obj);
#line 543 "AppLock.c"
}


GType app_lock_get_type (void) {
	static volatile gsize app_lock_type_id__volatile = 0;
	if (g_once_init_enter (&app_lock_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppLockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_lock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppLock), 0, (GInstanceInitFunc) app_lock_instance_init, NULL };
		GType app_lock_type_id;
		app_lock_type_id = g_type_register_static (G_TYPE_OBJECT, "AppLock", &g_define_type_info, 0);
		g_once_init_leave (&app_lock_type_id__volatile, app_lock_type_id);
	}
	return app_lock_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



