/* CronTab.c generated by valac 0.38.10, the Vala compiler
 * generated from CronTab.vala, do not modify */

/*
 * CronTab.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gee.h>


#define TYPE_CRON_TAB (cron_tab_get_type ())
#define CRON_TAB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CRON_TAB, CronTab))
#define CRON_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CRON_TAB, CronTabClass))
#define IS_CRON_TAB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CRON_TAB))
#define IS_CRON_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CRON_TAB))
#define CRON_TAB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CRON_TAB, CronTabClass))

typedef struct _CronTab CronTab;
typedef struct _CronTabClass CronTabClass;
typedef struct _CronTabPrivate CronTabPrivate;
enum  {
	CRON_TAB_0_PROPERTY,
	CRON_TAB_NUM_PROPERTIES
};
static GParamSpec* cron_tab_properties[CRON_TAB_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

struct _CronTab {
	GObject parent_instance;
	CronTabPrivate * priv;
};

struct _CronTabClass {
	GObjectClass parent_class;
};


static gpointer cron_tab_parent_class = NULL;
extern gchar* cron_tab_crontab_text;
gchar* cron_tab_crontab_text = NULL;

GType cron_tab_get_type (void) G_GNUC_CONST;
void cron_tab_clear_cached_text (void);
gchar* cron_tab_crontab_read_all (const gchar* user_name);
void tee_jee_logging_log_debug (const gchar* message);
gint tee_jee_process_helper_exec_sync (const gchar* cmd, gchar* * std_out, gchar* * std_err);
gboolean cron_tab_has_job (const gchar* entry, gboolean partial_match, gboolean use_cached_text);
gboolean cron_tab_add_job (const gchar* entry, gboolean use_cached_text);
gchar* tee_jee_process_helper_get_temp_file_path (void);
gboolean tee_jee_file_system_file_write (const gchar* file_path, const gchar* contents);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
void tee_jee_logging_log_msg (const gchar* message, gboolean highlight);
gboolean cron_tab_remove_job (const gchar* entry, gboolean use_regex, gboolean use_cached_text);
gboolean cron_tab_install (const gchar* file_path, const gchar* user_name);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gboolean cron_tab_export (const gchar* file_path, const gchar* user_name);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
gboolean cron_tab_import (const gchar* file_path, const gchar* user_name);
gboolean cron_tab_add_script_file (const gchar* file_name, const gchar* cron_dir_type, const gchar* text, gboolean stop_cron_emails);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
gboolean tee_jee_file_system_chown (const gchar* dir_path, const gchar* user, const gchar* group);
gint tee_jee_file_system_chmod (const gchar* file, const gchar* permission);
gboolean cron_tab_remove_script_file (const gchar* file_name, const gchar* cron_dir_type);
CronTab* cron_tab_new (void);
CronTab* cron_tab_construct (GType object_type);
static void cron_tab_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


void cron_tab_clear_cached_text (void) {
#line 34 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (cron_tab_crontab_text);
#line 34 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	cron_tab_crontab_text = NULL;
#line 106 "CronTab.c"
}


gchar* cron_tab_crontab_read_all (const gchar* user_name) {
	gchar* result = NULL;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp9_;
	gint ret_val = 0;
	const gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gint _tmp13_;
	gint _tmp14_;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (user_name != NULL, NULL);
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp0_ = g_strdup ("crontab -l");
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	cmd = _tmp0_;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp1_ = user_name;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp2_ = strlen (_tmp1_);
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp3_ = _tmp2_;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp3_ > 0) {
#line 140 "CronTab.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp4_ = cmd;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp5_ = user_name;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp6_ = g_strdup_printf (" -u %s", _tmp5_);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp7_ = _tmp6_;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp8_ = g_strconcat (_tmp4_, _tmp7_, NULL);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cmd);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		cmd = _tmp8_;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp7_);
#line 162 "CronTab.c"
	}
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp9_ = cmd;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tee_jee_logging_log_debug (_tmp9_);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp10_ = cmd;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp13_ = tee_jee_process_helper_exec_sync (_tmp10_, &_tmp11_, &_tmp12_);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (std_out);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	std_out = _tmp11_;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (std_err);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	std_err = _tmp12_;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	ret_val = _tmp13_;
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp14_ = ret_val;
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp14_ != 0) {
#line 186 "CronTab.c"
		gchar* _tmp15_;
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_debug (_ ("Failed to read cron tab"));
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp15_ = g_strdup ("");
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = _tmp15_;
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cmd);
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (std_err);
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (std_out);
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 202 "CronTab.c"
	} else {
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = std_out;
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cmd);
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (std_err);
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 212 "CronTab.c"
	}
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (cmd);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (std_err);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (std_out);
#line 220 "CronTab.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	return self ? g_object_ref (self) : NULL;
#line 227 "CronTab.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 247 "CronTab.c"
}


gboolean cron_tab_has_job (const gchar* entry, gboolean partial_match, gboolean use_cached_text) {
	gboolean result = FALSE;
	gchar* tab = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	GeeArrayList* lines = NULL;
	GeeArrayList* _tmp9_;
	const gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
#line 58 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (entry != NULL, FALSE);
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp0_ = g_strdup ("");
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tab = _tmp0_;
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp2_ = use_cached_text;
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp2_) {
#line 272 "CronTab.c"
		const gchar* _tmp3_;
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp3_ = cron_tab_crontab_text;
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 278 "CronTab.c"
	} else {
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp1_ = FALSE;
#line 282 "CronTab.c"
	}
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp1_) {
#line 286 "CronTab.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp4_ = cron_tab_crontab_text;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tab = _tmp5_;
#line 297 "CronTab.c"
	} else {
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp6_ = cron_tab_crontab_read_all ("");
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cron_tab_crontab_text);
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		cron_tab_crontab_text = _tmp6_;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp7_ = cron_tab_crontab_text;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tab = _tmp8_;
#line 316 "CronTab.c"
	}
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp9_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	lines = _tmp9_;
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp10_ = tab;
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, "\n", 0);
#line 326 "CronTab.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		line_collection = _tmp12_;
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		line_collection_length1 = _vala_array_length (_tmp11_);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp11_); line_it = line_it + 1) {
#line 338 "CronTab.c"
			gchar* _tmp13_;
			gchar* line = NULL;
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp13_ = g_strdup (line_collection[line_it]);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			line = _tmp13_;
#line 345 "CronTab.c"
			{
				GeeArrayList* _tmp14_;
				const gchar* _tmp15_;
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp14_ = lines;
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp15_ = line;
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (line);
#line 357 "CronTab.c"
			}
		}
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 362 "CronTab.c"
	}
	{
		GeeArrayList* _line_list = NULL;
		GeeArrayList* _tmp16_;
		GeeArrayList* _tmp17_;
		gint _line_size = 0;
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gint _line_index = 0;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp16_ = lines;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp17_ = _g_object_ref0 (_tmp16_);
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_list = _tmp17_;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp18_ = _line_list;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp20_ = _tmp19_;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_size = _tmp20_;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_index = -1;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		while (TRUE) {
#line 391 "CronTab.c"
			gint _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			gchar* line = NULL;
			GeeArrayList* _tmp24_;
			gint _tmp25_;
			gpointer _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp21_ = _line_index;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_line_index = _tmp21_ + 1;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp22_ = _line_index;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp23_ = _line_size;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			if (!(_tmp22_ < _tmp23_)) {
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				break;
#line 413 "CronTab.c"
			}
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp24_ = _line_list;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp25_ = _line_index;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, _tmp25_);
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			line = (gchar*) _tmp26_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp27_ = line;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp28_ = entry;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			if (g_strcmp0 (_tmp27_, _tmp28_) == 0) {
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				result = TRUE;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (line);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_object_unref0 (_line_list);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_object_unref0 (lines);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (tab);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				return result;
#line 441 "CronTab.c"
			} else {
				gboolean _tmp29_ = FALSE;
				gboolean _tmp30_;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp30_ = partial_match;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				if (_tmp30_) {
#line 449 "CronTab.c"
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean _tmp33_;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp31_ = line;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp32_ = entry;
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp33_ = string_contains (_tmp31_, _tmp32_);
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp29_ = _tmp33_;
#line 461 "CronTab.c"
				} else {
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp29_ = FALSE;
#line 465 "CronTab.c"
				}
#line 80 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				if (_tmp29_) {
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					result = TRUE;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_g_free0 (line);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_g_object_unref0 (_line_list);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_g_object_unref0 (lines);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_g_free0 (tab);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					return result;
#line 481 "CronTab.c"
				}
			}
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_g_free0 (line);
#line 486 "CronTab.c"
		}
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_object_unref0 (_line_list);
#line 490 "CronTab.c"
	}
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	result = FALSE;
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_object_unref0 (lines);
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (tab);
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	return result;
#line 500 "CronTab.c"
}


gboolean cron_tab_add_job (const gchar* entry, gboolean use_cached_text) {
	gboolean result = FALSE;
	gchar* tab = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	GeeArrayList* lines = NULL;
	GeeArrayList* _tmp9_;
	const gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	GeeArrayList* _tmp29_;
	const gchar* _tmp30_;
	gchar* tab_new = NULL;
	gchar* _tmp31_;
	gchar* temp_file = NULL;
	gchar* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	gchar* cmd = NULL;
	const gchar* _tmp54_;
	gchar* _tmp55_;
	gint status = 0;
	const gchar* _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (entry != NULL, FALSE);
#line 91 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp0_ = g_strdup ("");
#line 91 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tab = _tmp0_;
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp2_ = use_cached_text;
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp2_) {
#line 540 "CronTab.c"
		const gchar* _tmp3_;
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp3_ = cron_tab_crontab_text;
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 546 "CronTab.c"
	} else {
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp1_ = FALSE;
#line 550 "CronTab.c"
	}
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp1_) {
#line 554 "CronTab.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp4_ = cron_tab_crontab_text;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tab = _tmp5_;
#line 565 "CronTab.c"
	} else {
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp6_ = cron_tab_crontab_read_all ("");
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cron_tab_crontab_text);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		cron_tab_crontab_text = _tmp6_;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp7_ = cron_tab_crontab_text;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tab = _tmp8_;
#line 584 "CronTab.c"
	}
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp9_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	lines = _tmp9_;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp10_ = tab;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, "\n", 0);
#line 594 "CronTab.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		line_collection = _tmp12_;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		line_collection_length1 = _vala_array_length (_tmp11_);
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp11_); line_it = line_it + 1) {
#line 606 "CronTab.c"
			gchar* _tmp13_;
			gchar* line = NULL;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp13_ = g_strdup (line_collection[line_it]);
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			line = _tmp13_;
#line 613 "CronTab.c"
			{
				GeeArrayList* _tmp14_;
				const gchar* _tmp15_;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp14_ = lines;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp15_ = line;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (line);
#line 625 "CronTab.c"
			}
		}
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 630 "CronTab.c"
	}
	{
		GeeArrayList* _line_list = NULL;
		GeeArrayList* _tmp16_;
		GeeArrayList* _tmp17_;
		gint _line_size = 0;
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gint _line_index = 0;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp16_ = lines;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp17_ = _g_object_ref0 (_tmp16_);
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_list = _tmp17_;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp18_ = _line_list;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp20_ = _tmp19_;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_size = _tmp20_;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_index = -1;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		while (TRUE) {
#line 659 "CronTab.c"
			gint _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			gchar* line = NULL;
			GeeArrayList* _tmp24_;
			gint _tmp25_;
			gpointer _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp21_ = _line_index;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_line_index = _tmp21_ + 1;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp22_ = _line_index;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp23_ = _line_size;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			if (!(_tmp22_ < _tmp23_)) {
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				break;
#line 681 "CronTab.c"
			}
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp24_ = _line_list;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp25_ = _line_index;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, _tmp25_);
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			line = (gchar*) _tmp26_;
#line 107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp27_ = line;
#line 107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp28_ = entry;
#line 107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			if (g_strcmp0 (_tmp27_, _tmp28_) == 0) {
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				result = TRUE;
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (line);
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_object_unref0 (_line_list);
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_object_unref0 (lines);
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (tab);
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				return result;
#line 709 "CronTab.c"
			}
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_g_free0 (line);
#line 713 "CronTab.c"
		}
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_object_unref0 (_line_list);
#line 717 "CronTab.c"
	}
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp29_ = lines;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp30_ = entry;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp31_ = g_strdup ("");
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tab_new = _tmp31_;
#line 729 "CronTab.c"
	{
		GeeArrayList* _line_list = NULL;
		GeeArrayList* _tmp32_;
		GeeArrayList* _tmp33_;
		gint _line_size = 0;
		GeeArrayList* _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
		gint _line_index = 0;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp32_ = lines;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp33_ = _g_object_ref0 (_tmp32_);
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_list = _tmp33_;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp34_ = _line_list;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp36_ = _tmp35_;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_size = _tmp36_;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_index = -1;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		while (TRUE) {
#line 757 "CronTab.c"
			gint _tmp37_;
			gint _tmp38_;
			gint _tmp39_;
			gchar* line = NULL;
			GeeArrayList* _tmp40_;
			gint _tmp41_;
			gpointer _tmp42_;
			const gchar* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp37_ = _line_index;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_line_index = _tmp37_ + 1;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp38_ = _line_index;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp39_ = _line_size;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			if (!(_tmp38_ < _tmp39_)) {
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				break;
#line 780 "CronTab.c"
			}
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp40_ = _line_list;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp41_ = _line_index;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp40_, _tmp41_);
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			line = (gchar*) _tmp42_;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp43_ = line;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp44_ = strlen (_tmp43_);
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp45_ = _tmp44_;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			if (_tmp45_ > 0) {
#line 798 "CronTab.c"
				const gchar* _tmp46_;
				const gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp46_ = tab_new;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp47_ = line;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp48_ = g_strdup_printf ("%s\n", _tmp47_);
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp49_ = _tmp48_;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp50_ = g_strconcat (_tmp46_, _tmp49_, NULL);
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (tab_new);
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				tab_new = _tmp50_;
#line 119 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (_tmp49_);
#line 820 "CronTab.c"
			}
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_g_free0 (line);
#line 824 "CronTab.c"
		}
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_object_unref0 (_line_list);
#line 828 "CronTab.c"
	}
#line 124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp51_ = tee_jee_process_helper_get_temp_file_path ();
#line 124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	temp_file = _tmp51_;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp52_ = temp_file;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp53_ = tab_new;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tee_jee_file_system_file_write (_tmp52_, _tmp53_);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp54_ = temp_file;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp55_ = g_strdup_printf ("crontab \"%s\"", _tmp54_);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	cmd = _tmp55_;
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp56_ = cmd;
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp57_ = tee_jee_process_helper_exec_sync (_tmp56_, NULL, NULL);
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	status = _tmp57_;
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp58_ = status;
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp58_ != 0) {
#line 856 "CronTab.c"
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp59_ = entry;
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp60_ = g_strdup_printf (": %s", _tmp59_);
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp61_ = _tmp60_;
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp62_ = g_strconcat (_ ("Failed to add cron job"), _tmp61_, NULL);
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp63_ = _tmp62_;
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_error (_tmp63_, FALSE, FALSE);
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp63_);
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp61_);
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = FALSE;
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cmd);
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (temp_file);
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab_new);
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_object_unref0 (lines);
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 892 "CronTab.c"
	} else {
		const gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp64_ = entry;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp65_ = g_strdup_printf (": %s", _tmp64_);
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp66_ = _tmp65_;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp67_ = g_strconcat (_ ("Cron job added"), _tmp66_, NULL);
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp68_ = _tmp67_;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_msg (_tmp68_, FALSE);
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp68_);
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp66_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = TRUE;
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cmd);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (temp_file);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab_new);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_object_unref0 (lines);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 929 "CronTab.c"
	}
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (cmd);
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (temp_file);
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (tab_new);
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_object_unref0 (lines);
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (tab);
#line 941 "CronTab.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1242 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _result_;
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 964 "CronTab.c"
}


gboolean cron_tab_remove_job (const gchar* entry, gboolean use_regex, gboolean use_cached_text) {
	gboolean result = FALSE;
	gchar* tab = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	GeeArrayList* lines = NULL;
	GeeArrayList* _tmp9_;
	const gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	GRegex* regex = NULL;
	gboolean _tmp16_;
	gboolean found = FALSE;
	gboolean _tmp49_;
	gchar* tab_new = NULL;
	gchar* _tmp50_;
	gchar* temp_file = NULL;
	gchar* _tmp70_;
	const gchar* _tmp71_;
	const gchar* _tmp72_;
	gchar* cmd = NULL;
	const gchar* _tmp73_;
	gchar* _tmp74_;
	gint status = 0;
	const gchar* _tmp75_;
	gint _tmp76_;
	gint _tmp77_;
	GError * _inner_error_ = NULL;
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (entry != NULL, FALSE);
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp0_ = g_strdup ("");
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tab = _tmp0_;
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp2_ = use_cached_text;
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp2_) {
#line 1007 "CronTab.c"
		const gchar* _tmp3_;
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp3_ = cron_tab_crontab_text;
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 1013 "CronTab.c"
	} else {
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp1_ = FALSE;
#line 1017 "CronTab.c"
	}
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp1_) {
#line 1021 "CronTab.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp4_ = cron_tab_crontab_text;
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tab = _tmp5_;
#line 1032 "CronTab.c"
	} else {
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp6_ = cron_tab_crontab_read_all ("");
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cron_tab_crontab_text);
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		cron_tab_crontab_text = _tmp6_;
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp7_ = cron_tab_crontab_text;
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tab = _tmp8_;
#line 1051 "CronTab.c"
	}
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp9_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	lines = _tmp9_;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp10_ = tab;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, "\n", 0);
#line 1061 "CronTab.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		line_collection = _tmp12_;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		line_collection_length1 = _vala_array_length (_tmp11_);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp11_); line_it = line_it + 1) {
#line 1073 "CronTab.c"
			gchar* _tmp13_;
			gchar* line = NULL;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp13_ = g_strdup (line_collection[line_it]);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			line = _tmp13_;
#line 1080 "CronTab.c"
			{
				GeeArrayList* _tmp14_;
				const gchar* _tmp15_;
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp14_ = lines;
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp15_ = line;
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (line);
#line 1092 "CronTab.c"
			}
		}
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1097 "CronTab.c"
	}
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	regex = NULL;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp16_ = use_regex;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp16_) {
#line 1105 "CronTab.c"
		{
			GRegex* _tmp17_ = NULL;
			const gchar* _tmp18_;
			GRegex* _tmp19_;
			GRegex* _tmp20_;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp18_ = entry;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp19_ = g_regex_new (_tmp18_, 0, 0, &_inner_error_);
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp17_ = _tmp19_;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1119 "CronTab.c"
				goto __catch38_g_error;
			}
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp20_ = _tmp17_;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp17_ = NULL;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_g_regex_unref0 (regex);
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			regex = _tmp20_;
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_g_regex_unref0 (_tmp17_);
#line 1132 "CronTab.c"
		}
		goto __finally38;
		__catch38_g_error:
		{
			GError* e = NULL;
			GError* _tmp21_;
			const gchar* _tmp22_;
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			e = _inner_error_;
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_inner_error_ = NULL;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp21_ = e;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp22_ = _tmp21_->message;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_g_error_free0 (e);
#line 1152 "CronTab.c"
		}
		__finally38:
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1157 "CronTab.c"
			gboolean _tmp23_ = FALSE;
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_g_regex_unref0 (regex);
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_g_object_unref0 (lines);
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_g_free0 (tab);
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			g_clear_error (&_inner_error_);
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			return _tmp23_;
#line 1171 "CronTab.c"
		}
	}
#line 170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	found = FALSE;
#line 1176 "CronTab.c"
	{
		gint i = 0;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		i = 0;
#line 1181 "CronTab.c"
		{
			gboolean _tmp24_ = FALSE;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp24_ = TRUE;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			while (TRUE) {
#line 1188 "CronTab.c"
				gint _tmp26_;
				GeeArrayList* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gchar* line = NULL;
				GeeArrayList* _tmp30_;
				gint _tmp31_;
				gpointer _tmp32_;
				const gchar* _tmp33_;
				gboolean _tmp36_ = FALSE;
				gboolean _tmp37_;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				if (!_tmp24_) {
#line 1202 "CronTab.c"
					gint _tmp25_;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp25_ = i;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					i = _tmp25_ + 1;
#line 1208 "CronTab.c"
				}
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp24_ = FALSE;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp26_ = i;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp27_ = lines;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp29_ = _tmp28_;
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				if (!(_tmp26_ < _tmp29_)) {
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					break;
#line 1224 "CronTab.c"
				}
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp30_ = lines;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp31_ = i;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _tmp31_);
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				line = (gchar*) _tmp32_;
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp33_ = line;
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				if (_tmp33_ != NULL) {
#line 1238 "CronTab.c"
					const gchar* _tmp34_;
					gchar* _tmp35_;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp34_ = line;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp35_ = string_strip (_tmp34_);
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_g_free0 (line);
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					line = _tmp35_;
#line 1249 "CronTab.c"
				}
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp37_ = use_regex;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				if (_tmp37_) {
#line 1255 "CronTab.c"
					GRegex* _tmp38_;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp38_ = regex;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp36_ = _tmp38_ != NULL;
#line 1261 "CronTab.c"
				} else {
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp36_ = FALSE;
#line 1265 "CronTab.c"
				}
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				if (_tmp36_) {
#line 1269 "CronTab.c"
					GMatchInfo* match = NULL;
					GRegex* _tmp39_;
					const gchar* _tmp40_;
					GMatchInfo* _tmp41_ = NULL;
					gboolean _tmp42_;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp39_ = regex;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp40_ = line;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp42_ = g_regex_match (_tmp39_, _tmp40_, 0, &_tmp41_);
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_g_match_info_unref0 (match);
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					match = _tmp41_;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					if (_tmp42_) {
#line 1287 "CronTab.c"
						GeeArrayList* _tmp43_;
						const gchar* _tmp44_;
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
						_tmp43_ = lines;
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
						_tmp44_ = line;
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp43_, _tmp44_);
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
						found = TRUE;
#line 1298 "CronTab.c"
					}
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_g_match_info_unref0 (match);
#line 1302 "CronTab.c"
				} else {
					const gchar* _tmp45_;
					const gchar* _tmp46_;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp45_ = line;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					_tmp46_ = entry;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
					if (g_strcmp0 (_tmp45_, _tmp46_) == 0) {
#line 1312 "CronTab.c"
						GeeArrayList* _tmp47_;
						const gchar* _tmp48_;
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
						_tmp47_ = lines;
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
						_tmp48_ = line;
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp47_, _tmp48_);
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
						found = TRUE;
#line 1323 "CronTab.c"
					}
				}
#line 171 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (line);
#line 1328 "CronTab.c"
			}
		}
	}
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp49_ = found;
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (!_tmp49_) {
#line 193 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = TRUE;
#line 193 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_regex_unref0 (regex);
#line 193 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_object_unref0 (lines);
#line 193 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 193 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 1346 "CronTab.c"
	}
#line 197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp50_ = g_strdup ("");
#line 197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tab_new = _tmp50_;
#line 1352 "CronTab.c"
	{
		GeeArrayList* _line_list = NULL;
		GeeArrayList* _tmp51_;
		GeeArrayList* _tmp52_;
		gint _line_size = 0;
		GeeArrayList* _tmp53_;
		gint _tmp54_;
		gint _tmp55_;
		gint _line_index = 0;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp51_ = lines;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp52_ = _g_object_ref0 (_tmp51_);
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_list = _tmp52_;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp53_ = _line_list;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp54_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp53_);
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp55_ = _tmp54_;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_size = _tmp55_;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_line_index = -1;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		while (TRUE) {
#line 1380 "CronTab.c"
			gint _tmp56_;
			gint _tmp57_;
			gint _tmp58_;
			gchar* line = NULL;
			GeeArrayList* _tmp59_;
			gint _tmp60_;
			gpointer _tmp61_;
			const gchar* _tmp62_;
			gint _tmp63_;
			gint _tmp64_;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp56_ = _line_index;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_line_index = _tmp56_ + 1;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp57_ = _line_index;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp58_ = _line_size;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			if (!(_tmp57_ < _tmp58_)) {
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				break;
#line 1403 "CronTab.c"
			}
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp59_ = _line_list;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp60_ = _line_index;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp61_ = gee_abstract_list_get ((GeeAbstractList*) _tmp59_, _tmp60_);
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			line = (gchar*) _tmp61_;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp62_ = line;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp63_ = strlen (_tmp62_);
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_tmp64_ = _tmp63_;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			if (_tmp64_ > 0) {
#line 1421 "CronTab.c"
				const gchar* _tmp65_;
				const gchar* _tmp66_;
				gchar* _tmp67_;
				gchar* _tmp68_;
				gchar* _tmp69_;
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp65_ = tab_new;
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp66_ = line;
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp67_ = g_strdup_printf ("%s\n", _tmp66_);
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp68_ = _tmp67_;
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp69_ = g_strconcat (_tmp65_, _tmp68_, NULL);
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (tab_new);
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				tab_new = _tmp69_;
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (_tmp68_);
#line 1443 "CronTab.c"
			}
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
			_g_free0 (line);
#line 1447 "CronTab.c"
		}
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_object_unref0 (_line_list);
#line 1451 "CronTab.c"
	}
#line 205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp70_ = tee_jee_process_helper_get_temp_file_path ();
#line 205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	temp_file = _tmp70_;
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp71_ = temp_file;
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp72_ = tab_new;
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tee_jee_file_system_file_write (_tmp71_, _tmp72_);
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp73_ = temp_file;
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp74_ = g_strdup_printf ("crontab \"%s\"", _tmp73_);
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	cmd = _tmp74_;
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp75_ = cmd;
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp76_ = tee_jee_process_helper_exec_sync (_tmp75_, NULL, NULL);
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	status = _tmp76_;
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp77_ = status;
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp77_ != 0) {
#line 1479 "CronTab.c"
		const gchar* _tmp78_;
		gchar* _tmp79_;
		gchar* _tmp80_;
		gchar* _tmp81_;
		gchar* _tmp82_;
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp78_ = entry;
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp79_ = g_strdup_printf (": %s", _tmp78_);
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp80_ = _tmp79_;
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp81_ = g_strconcat (_ ("Failed to remove cron job"), _tmp80_, NULL);
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp82_ = _tmp81_;
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_error (_tmp82_, FALSE, FALSE);
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp82_);
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp80_);
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = FALSE;
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cmd);
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (temp_file);
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab_new);
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_regex_unref0 (regex);
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_object_unref0 (lines);
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 1517 "CronTab.c"
	} else {
		const gchar* _tmp83_;
		gchar* _tmp84_;
		gchar* _tmp85_;
		gchar* _tmp86_;
		gchar* _tmp87_;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp83_ = entry;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp84_ = g_strdup_printf (": %s", _tmp83_);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp85_ = _tmp84_;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp86_ = g_strconcat (_ ("Cron job removed"), _tmp85_, NULL);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp87_ = _tmp86_;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_msg (_tmp87_, FALSE);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp87_);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp85_);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = TRUE;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cmd);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (temp_file);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab_new);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_regex_unref0 (regex);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_object_unref0 (lines);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (tab);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 1556 "CronTab.c"
	}
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (cmd);
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (temp_file);
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (tab_new);
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_regex_unref0 (regex);
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_object_unref0 (lines);
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (tab);
#line 1570 "CronTab.c"
}


gboolean cron_tab_install (const gchar* file_path, const gchar* user_name) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gchar* cmd = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	gint status = 0;
	const gchar* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
#line 222 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 222 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (user_name != NULL, FALSE);
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp0_ = file_path;
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp1_ = tee_jee_file_system_file_exists (_tmp0_);
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (!_tmp1_) {
#line 1603 "CronTab.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp2_ = file_path;
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp3_ = g_strdup_printf (": %s", _tmp2_);
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp4_ = _tmp3_;
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp5_ = g_strconcat (_ ("File not found"), _tmp4_, NULL);
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp6_ = _tmp5_;
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp6_);
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp4_);
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = FALSE;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 1629 "CronTab.c"
	}
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp7_ = g_strdup ("crontab");
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	cmd = _tmp7_;
#line 230 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp8_ = user_name;
#line 230 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp9_ = strlen (_tmp8_);
#line 230 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp10_ = _tmp9_;
#line 230 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp10_ > 0) {
#line 1643 "CronTab.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp11_ = cmd;
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp12_ = user_name;
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp13_ = g_strdup_printf (" -u %s", _tmp12_);
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp14_ = _tmp13_;
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cmd);
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		cmd = _tmp15_;
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp14_);
#line 1665 "CronTab.c"
	}
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp16_ = cmd;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp17_ = file_path;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp18_ = g_strdup_printf (" \"%s\"", _tmp17_);
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp19_ = _tmp18_;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp20_ = g_strconcat (_tmp16_, _tmp19_, NULL);
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (cmd);
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	cmd = _tmp20_;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (_tmp19_);
#line 235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp21_ = cmd;
#line 235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tee_jee_logging_log_debug (_tmp21_);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp22_ = cmd;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp23_ = tee_jee_process_helper_exec_sync (_tmp22_, NULL, NULL);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	status = _tmp23_;
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp24_ = status;
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp24_ != 0) {
#line 1697 "CronTab.c"
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp25_ = file_path;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp26_ = g_strdup_printf (": %s", _tmp25_);
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp27_ = _tmp26_;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp28_ = g_strconcat (_ ("Failed to install crontab file"), _tmp27_, NULL);
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp29_ = _tmp28_;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_error (_tmp29_, FALSE, FALSE);
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp29_);
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp27_);
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = FALSE;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cmd);
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 1725 "CronTab.c"
	} else {
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp30_ = file_path;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp31_ = g_strdup_printf (": %s", _tmp30_);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp32_ = _tmp31_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp33_ = g_strconcat (_ ("crontab file installed"), _tmp32_, NULL);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp34_ = _tmp33_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_msg (_tmp34_, FALSE);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp34_);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp32_);
#line 245 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = TRUE;
#line 245 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (cmd);
#line 245 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 1754 "CronTab.c"
	}
#line 222 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (cmd);
#line 1758 "CronTab.c"
}


gboolean cron_tab_export (const gchar* file_path, const gchar* user_name) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gboolean ok = FALSE;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (user_name != NULL, FALSE);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp0_ = file_path;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp1_ = tee_jee_file_system_file_exists (_tmp0_);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp1_) {
#line 1784 "CronTab.c"
		const gchar* _tmp2_;
#line 251 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp2_ = file_path;
#line 251 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_file_system_file_delete (_tmp2_);
#line 1790 "CronTab.c"
	}
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp3_ = file_path;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp4_ = user_name;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp5_ = cron_tab_crontab_read_all (_tmp4_);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp6_ = _tmp5_;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp7_ = tee_jee_file_system_file_write (_tmp3_, _tmp6_);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp8_ = _tmp7_;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (_tmp6_);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	ok = _tmp8_;
#line 256 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp9_ = ok;
#line 256 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (!_tmp9_) {
#line 1812 "CronTab.c"
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp10_ = file_path;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp11_ = g_strdup_printf (": %s", _tmp10_);
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp12_ = _tmp11_;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp13_ = g_strconcat (_ ("Failed to export crontab file"), _tmp12_, NULL);
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp14_ = _tmp13_;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_error (_tmp14_, FALSE, FALSE);
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp14_);
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp12_);
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = FALSE;
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 1838 "CronTab.c"
	} else {
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp15_ = file_path;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp16_ = g_strdup_printf (": %s", _tmp15_);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp17_ = _tmp16_;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp18_ = g_strconcat (_ ("crontab file exported"), _tmp17_, NULL);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp19_ = _tmp18_;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_msg (_tmp19_, FALSE);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp19_);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp17_);
#line 262 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = TRUE;
#line 262 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 1865 "CronTab.c"
	}
}


gboolean cron_tab_import (const gchar* file_path, const gchar* user_name) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
#line 266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (user_name != NULL, FALSE);
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp0_ = file_path;
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp1_ = user_name;
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp2_ = cron_tab_install (_tmp0_, _tmp1_);
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	result = _tmp2_;
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	return result;
#line 1889 "CronTab.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1908 "CronTab.c"
	} else {
		const gchar* _tmp2_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp2_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
#line 1915 "CronTab.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1921 "CronTab.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = replacement;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
#line 1931 "CronTab.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1935 "CronTab.c"
		gchar* _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp5_ = g_strdup (self);
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 1943 "CronTab.c"
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp6_ = old;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp9_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp8_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		regex = _tmp10_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 1975 "CronTab.c"
				goto __catch39_g_regex_error;
			}
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 1984 "CronTab.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = regex;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp13_ = replacement;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = _tmp14_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 2000 "CronTab.c"
				goto __catch39_g_regex_error;
			}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 2011 "CronTab.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp15_ = _tmp11_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = NULL;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp15_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp11_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 2025 "CronTab.c"
	}
	goto __finally39;
	__catch39_g_regex_error:
	{
		GError* e = NULL;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1423 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 2039 "CronTab.c"
	}
	__finally39:
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return NULL;
#line 2050 "CronTab.c"
	}
}


gboolean cron_tab_add_script_file (const gchar* file_name, const gchar* cron_dir_type, const gchar* text, gboolean stop_cron_emails) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	static GQuark _tmp2_label0 = 0;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	static GQuark _tmp2_label1 = 0;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	static GQuark _tmp2_label2 = 0;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	static GQuark _tmp2_label3 = 0;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	static GQuark _tmp2_label4 = 0;
#line 2070 "CronTab.c"
	gchar* file_path = NULL;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* sh = NULL;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gboolean _tmp30_ = FALSE;
	const gchar* _tmp31_;
	gboolean _tmp32_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (file_name != NULL, FALSE);
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (cron_dir_type != NULL, FALSE);
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp0_ = cron_dir_type;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp1_ = _tmp0_;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("d")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("hourly"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("daily"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("weekly"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("monthly"))))) {
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		switch (0) {
#line 2120 "CronTab.c"
			default:
			{
#line 285 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				break;
#line 2125 "CronTab.c"
			}
		}
	} else {
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		switch (0) {
#line 2131 "CronTab.c"
			default:
			{
				const gchar* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp4_ = cron_dir_type;
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp5_ = g_strdup_printf (": %s", _tmp4_);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp6_ = _tmp5_;
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp7_ = g_strconcat ("Cron directory type parameter not valid", _tmp6_, NULL);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp8_ = _tmp7_;
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (_tmp8_);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (_tmp6_);
#line 288 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				tee_jee_logging_log_error ("Expected values: d, hourly, daily, weekly, monthly", FALSE, FALSE);
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				result = FALSE;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				return result;
#line 2161 "CronTab.c"
			}
		}
	}
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp9_ = cron_dir_type;
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp10_ = file_name;
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp11_ = string_replace (_tmp10_, ".", "-");
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp12_ = _tmp11_;
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp13_ = g_strdup_printf ("/etc/cron.%s/%s", _tmp9_, _tmp12_);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp14_ = _tmp13_;
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (_tmp12_);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	file_path = _tmp14_;
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp15_ = g_strdup ("");
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	sh = _tmp15_;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp16_ = sh;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp17_ = g_strconcat (_tmp16_, "SHELL=/bin/bash" "\n", NULL);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (sh);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	sh = _tmp17_;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp18_ = sh;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp19_ = g_strconcat (_tmp18_, "PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin" "\n", NULL);
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (sh);
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	sh = _tmp19_;
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp20_ = stop_cron_emails;
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp20_) {
#line 2205 "CronTab.c"
		const gchar* _tmp21_;
		gchar* _tmp22_;
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp21_ = sh;
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp22_ = g_strconcat (_tmp21_, "MAILTO=\"\"" "\n", NULL);
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (sh);
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		sh = _tmp22_;
#line 2216 "CronTab.c"
	}
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp23_ = sh;
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp24_ = g_strconcat (_tmp23_, "\n", NULL);
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (sh);
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	sh = _tmp24_;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp25_ = sh;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp26_ = text;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp27_ = g_strconcat (_tmp26_, "\n", NULL);
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp28_ = _tmp27_;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp29_ = g_strconcat (_tmp25_, _tmp28_, NULL);
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (sh);
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	sh = _tmp29_;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (_tmp28_);
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp31_ = file_path;
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp32_ = tee_jee_file_system_file_exists (_tmp31_);
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp32_) {
#line 2248 "CronTab.c"
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		const gchar* _tmp36_;
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp33_ = file_path;
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp34_ = tee_jee_file_system_file_read (_tmp33_);
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp35_ = _tmp34_;
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp36_ = sh;
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp30_ = g_strcmp0 (_tmp35_, _tmp36_) == 0;
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp35_);
#line 2265 "CronTab.c"
	} else {
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp30_ = FALSE;
#line 2269 "CronTab.c"
	}
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (_tmp30_) {
#line 2273 "CronTab.c"
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp37_ = file_path;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp38_ = g_strdup_printf (": %s", _tmp37_);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp39_ = _tmp38_;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp40_ = g_strconcat (_ ("Cron task exists"), _tmp39_, NULL);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_tmp41_ = _tmp40_;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		tee_jee_logging_log_debug (_tmp41_);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp41_);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (_tmp39_);
#line 305 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = TRUE;
#line 305 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (sh);
#line 305 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (file_path);
#line 305 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 2303 "CronTab.c"
	}
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp42_ = file_path;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp43_ = sh;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tee_jee_file_system_file_write (_tmp42_, _tmp43_);
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp44_ = file_path;
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tee_jee_file_system_chown (_tmp44_, "root", "root");
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp45_ = file_path;
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tee_jee_file_system_chmod (_tmp45_, "644");
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp46_ = file_path;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp47_ = g_strdup_printf (": %s", _tmp46_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp48_ = _tmp47_;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp49_ = g_strconcat (_ ("Added cron task"), _tmp48_, NULL);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp50_ = _tmp49_;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tee_jee_logging_log_msg (_tmp50_, FALSE);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (_tmp50_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (_tmp48_);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	result = TRUE;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (sh);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (file_path);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	return result;
#line 2343 "CronTab.c"
}


gboolean cron_tab_remove_script_file (const gchar* file_name, const gchar* cron_dir_type) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	static GQuark _tmp2_label0 = 0;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	static GQuark _tmp2_label1 = 0;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	static GQuark _tmp2_label2 = 0;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	static GQuark _tmp2_label3 = 0;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	static GQuark _tmp2_label4 = 0;
#line 2362 "CronTab.c"
	gchar* file_path = NULL;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gboolean _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (file_name != NULL, FALSE);
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	g_return_val_if_fail (cron_dir_type != NULL, FALSE);
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp0_ = cron_dir_type;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp1_ = _tmp0_;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("d")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("hourly"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("daily"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("weekly"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("monthly"))))) {
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		switch (0) {
#line 2392 "CronTab.c"
			default:
			{
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				break;
#line 2397 "CronTab.c"
			}
		}
	} else {
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		switch (0) {
#line 2403 "CronTab.c"
			default:
			{
				const gchar* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp4_ = cron_dir_type;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp5_ = g_strdup_printf (": %s", _tmp4_);
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp6_ = _tmp5_;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp7_ = g_strconcat ("Cron directory type parameter not valid", _tmp6_, NULL);
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_tmp8_ = _tmp7_;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (_tmp8_);
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				_g_free0 (_tmp6_);
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				tee_jee_logging_log_error ("Expected values: d, hourly, daily, weekly, monthly", FALSE, FALSE);
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				result = FALSE;
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				return result;
#line 330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
				break;
#line 2435 "CronTab.c"
			}
		}
	}
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp9_ = cron_dir_type;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp10_ = file_name;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp11_ = string_replace (_tmp10_, ".", "-");
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp12_ = _tmp11_;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp13_ = g_strdup_printf ("/etc/cron.%s/%s", _tmp9_, _tmp12_);
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp14_ = _tmp13_;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (_tmp12_);
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	file_path = _tmp14_;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp15_ = file_path;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp16_ = tee_jee_file_system_file_exists (_tmp15_);
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	if (!_tmp16_) {
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		result = TRUE;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		_g_free0 (file_path);
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
		return result;
#line 2467 "CronTab.c"
	}
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp17_ = file_path;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tee_jee_file_system_file_delete (_tmp17_);
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp18_ = file_path;
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp19_ = g_strdup_printf (": %s", _tmp18_);
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp20_ = _tmp19_;
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp21_ = g_strconcat (_ ("Removed cron task"), _tmp20_, NULL);
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_tmp22_ = _tmp21_;
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	tee_jee_logging_log_msg (_tmp22_, FALSE);
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (_tmp22_);
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (_tmp20_);
#line 343 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	result = TRUE;
#line 343 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	_g_free0 (file_path);
#line 343 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	return result;
#line 2495 "CronTab.c"
}


CronTab* cron_tab_construct (GType object_type) {
	CronTab * self = NULL;
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	self = (CronTab*) g_object_new (object_type, NULL);
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	return self;
#line 2505 "CronTab.c"
}


CronTab* cron_tab_new (void) {
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	return cron_tab_construct (TYPE_CRON_TAB);
#line 2512 "CronTab.c"
}


static void cron_tab_class_init (CronTabClass * klass) {
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	cron_tab_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	G_OBJECT_CLASS (klass)->finalize = cron_tab_finalize;
#line 2521 "CronTab.c"
}


static void cron_tab_instance_init (CronTab * self) {
}


static void cron_tab_finalize (GObject * obj) {
	CronTab * self;
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CRON_TAB, CronTab);
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CronTab.vala"
	G_OBJECT_CLASS (cron_tab_parent_class)->finalize (obj);
#line 2535 "CronTab.c"
}


GType cron_tab_get_type (void) {
	static volatile gsize cron_tab_type_id__volatile = 0;
	if (g_once_init_enter (&cron_tab_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CronTabClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cron_tab_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CronTab), 0, (GInstanceInitFunc) cron_tab_instance_init, NULL };
		GType cron_tab_type_id;
		cron_tab_type_id = g_type_register_static (G_TYPE_OBJECT, "CronTab", &g_define_type_info, 0);
		g_once_init_leave (&cron_tab_type_id__volatile, cron_tab_type_id);
	}
	return cron_tab_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



